SystemOrganization addCategory: #'MC2-SqueakPlatform'!

Object subclass: #MDAuthorInfo
	instanceVariableNames: ''
	classVariableNames: 'MDAuthor MDLastImageName'
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:23'!
initialize
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 12/28/2007 21:09'!
prompt
	^ ' Please enter you name and email address for Monticello2 '! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:10'!
shutDown
	MDLastImageName := SmalltalkImage current imageName! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:10'!
startUp
	MDLastImageName = SmalltalkImage current imageName ifFalse: [ MDAuthor := nil ]! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:09'!
value
	^ MDAuthor ifNil: 
		[ MDAuthor := MDPlatform current 
			prompt: self prompt
			default: '' ]! !

!MDAuthorInfo class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:09'!
value: aString 
	"Set the name and email address of the user of the system."
	MDAuthor := aString! !

Object subclass: #MDNotificationAdaptor
	instanceVariableNames: ''
	classVariableNames: 'MDInstance'
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDNotificationAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:10'!
default
	^ MDInstance ifNil: 
		[ MDInstance := self new.
		MDInstance register ]! !

!MDNotificationAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 8/3/2008 21:26'!
initialize
	self default! !

!MDNotificationAdaptor class methodsFor: 'as yet unclassified' stamp: 'cwp 10/2/2008 20:10'!
reset
	MDInstance ifNotNil: [ MDInstance unregister ].
	MDInstance := nil! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:08'!
announce: anElement toAll: objects startingAt: start
	| listener |
	(start to: objects size) do: 
		[:i | 
		[listener := objects at: i.
		listener ifNotNil: [listener noteElementChanged: anElement]]
			on: Halt, Exception
			do: 
				[:exc | 
				self announce: anElement toAll: objects startingAt: i+1.
				exc pass]]! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 5/22/2008 00:08'!
noteClassChanged: anEvent
	| element |
	element := MDClassElement className: anEvent item name.
	self noteElementChanged: element! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 5/22/2008 00:08'!
noteClassCommented: anEvent
	| element |
	element := MDClassCommentElement className: (anEvent item name).
	self noteElementChanged: element! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 4/7/2008 21:54'!
noteClassModified: anEvent

	anEvent item isMeta ifFalse: [self processClass: anEvent].
	anEvent areInstVarsModified ifTrue: [self processInstVars: anEvent].
	anEvent areClassVarsModified ifTrue: [self processClassVars: anEvent].
	anEvent areSharedPoolsModified ifTrue: [self processPools: anEvent].! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 7/30/2008 18:30'!
noteElementChanged: anElement
	MDAnnouncer announce: (MDElementModified for: anElement)! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 9/4/2009 09:58'!
noteMethodChanged: anEvent
	| element class selector |
	class := anEvent environmentAt: #class.
	selector := (anEvent environmentAt: #selector)
		ifNil: [anEvent item selector].
	element := MDMethodElement
				className: class theNonMetaClass name
				selector: selector
				classIsMeta: class isMeta.
	self noteElementChanged: element ! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:08'!
processClass: anEvent
	| element |
	(anEvent isSuperclassModified or: [anEvent item category ~= anEvent oldItem category])
		ifTrue:
			[element := MDClassElement className: anEvent item name.
			self noteElementChanged: element].! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:08'!
processClassVars: anEvent
	| changed element |
	changed := self xor: anEvent classVarNames with: anEvent oldClassVarNames.
	changed do:
		[:name |
		element := MDClassVarElement className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:08'!
processInstVars: anEvent
	| changed element class |
	changed := self xor: anEvent instVarNames with: anEvent oldInstVarNames.
	changed do:
		[:name |
		class := anEvent item isMeta ifTrue: [MDClassInstVarElement] ifFalse: [MDInstVarElement].
		element := class className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:08'!
processPools: anEvent
	| changed element name |
	changed := self xor: anEvent sharedPools with: anEvent oldSharedPools.
	changed do:
		[:pool |
		name := Smalltalk keyAtValue: pool.
		element := MDPoolImportElement className: anEvent item name name: name.
		self noteElementChanged: element]! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 15:14'!
register
	SystemChangeNotifier uniqueInstance 
		notify: self 
		ofSystemChangesOfItem: #class 
		change: #Commented 
		using: #noteClassCommented:;
		
		notify: self 
		ofSystemChangesOfItem: #class 
		change: #Modified 
		using: #noteClassModified:;
		
		notify: self
		ofSystemChangesOfItem: #class
		change: #Added
		using: #noteClassChanged:;
		
		notify: self
		ofSystemChangesOfItem: #method
		using: #noteMethodChanged:.! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 13:25'!
registerAll
	SystemChangeNotifier uniqueInstance 
		notify: self ofAllSystemChangesUsing: #transcribe:! !

!MDNotificationAdaptor methodsFor: 'callbacks' stamp: 'cwp 3/9/2008 13:26'!
transcribe: anEvent
	Transcript cr; show: anEvent asString! !

!MDNotificationAdaptor methodsFor: 'registration' stamp: 'cwp 3/9/2008 13:06'!
unregister
	SystemChangeNotifier uniqueInstance 
		noMoreNotificationsFor: self! !

!MDNotificationAdaptor methodsFor: 'private' stamp: 'cwp 5/22/2008 00:08'!
xor: left with: right
	| result |
	result := Set new.
	left do: [:ea | (right includes: ea) ifFalse: [result add: ea]].
	right do: [:ea | (left includes: ea) ifFalse: [result add: ea]].
	^ result! !

Object subclass: #MDPlatform
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

MDPlatform class
	instanceVariableNames: 'current'!

MDPlatform class
	instanceVariableNames: 'current'!

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 5/10/2008 18:51'!
current
	^ current ifNil: [current := self new]! !

!MDPlatform class methodsFor: 'as yet unclassified' stamp: 'cwp 5/10/2008 18:51'!
current: aPlatform
	current := aPlatform! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 6/23/2008 08:56'!
aboriginalAbc
	"A wide string containing the first 3 Canadian Aboriginal Syllabics, with unicode
	values U+1401, U+1402, U+1403. Each character is encoded as 4 bytes in the array literal"
	
	^ WideString fromByteArray: #(63 192 20 1 63 192 20 2 63 192 20 3)! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 10/20/2008 21:26'!
imageName
	^ SmalltalkImage current imageName! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 11/17/2007 01:25'!
initials
	^ Utilities authorInitials ! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 3/9/2008 16:08'!
notifier
	^ MDNotificationAdaptor default! !

!MDPlatform methodsFor: 'user interface' stamp: 'cwp 12/28/2007 21:06'!
prompt: prompt default: default
	^ OBTextRequest
		prompt: prompt
		template: default! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 4/7/2008 23:23'!
serializationMap
	^ MDSerializationMap new! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 5/3/2008 01:19'!
showCursor: aSymbol
	| cursor |
	cursor := aSymbol ifNotNil: [Cursor perform: aSymbol].
	ActiveHand showTemporaryCursor: cursor.
	World doOneCycleNow! !

!MDPlatform methodsFor: 'constructing' stamp: 'cwp 12/22/2006 22:25'!
systemEditor
	^ Smalltalk! !

!MDPlatform methodsFor: 'time' stamp: 'cwp 5/10/2008 18:40'!
timestampSeconds
	^ Time primSecondsClock - 2498169600! !

!MDPlatform methodsFor: 'image' stamp: 'cwp 12/28/2007 21:25'!
updateMemoProperties: properties
	properties 
		initials: Utilities authorInitials;
		author: MDAuthorInfo value! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 3/2/2008 12:19'!
variablePointersObject
	^ (ActionSequence new: 2)
		at: 1 put: #a;
		at: 2 put: #b;
		yourself! !

!MDPlatform methodsFor: 'testing' stamp: 'cwp 6/23/2008 08:42'!
wideString
	^ WideString fromString: 'abc'! !

!MDPlatform methodsFor: 'cursor' stamp: 'cwp 12/22/2007 22:27'!
withCursor: aSymbol do: aBlock
	self showCursor: aSymbol.
	^ aBlock ensure: [self showCursor: nil]! !

Object subclass: #MDSerializationMap
	instanceVariableNames: 'classMap typeMap defaultSerializer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 10:24'!
addHashedSerializersTo: map 
	| serializer |
	serializer := MDHashedObjectSerializer type: 23.
	MDHashedObject allSubclassesDo: 
		[ :class | map at: class put: serializer ]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 6/23/2008 08:31'!
addKnownClassesTo: map 
	self knownClasses withIndexDo:
		[:class :id |
		class ifNotNil:
			[map 
				at: class class
				put: (MDKnownClassSerializer id: id)]]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 13:45'!
createClassMap
	| map |
	map := IdentityDictionary new.
	map 
		at: UndefinedObject put: (MDSingletonSerializer type: 6);
		at: True put: (MDSingletonSerializer type: 7);
		at: False put: (MDSingletonSerializer type: 8);
		at: SmallInteger put: MDSmallIntegerSerializer new;
		at: LargePositiveInteger put: (MDLargeIntegerSerializer type: 12);
		at: LargeNegativeInteger put: (MDLargeIntegerSerializer type: 13);
		at: ByteSymbol put: (MDUtf8Serializer type: 14);
		at: WideSymbol put: (MDUtf8Serializer type: 14);
		at: ByteString put: (MDUtf8Serializer type: 15);
		at: WideString put: (MDUtf16Serializer type: 16);
		at: Array put: (MDArraySerializer type: 17);
		at: Set put: (MDSetSerializer type: 18);
		at: Dictionary put: (MDDictionarySerializer type: 19);
		at: MDPropertyDictionary put: (MDDictionarySerializer type: 20);
		at: MDTimestamp put: (MDBytesSerializer type: 21);
		at: MDHashstamp put: (MDBytesSerializer type: 22).
	self addHashedSerializersTo: map.
	self addKnownClassesTo: map.
	^ map! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 13:39'!
createTypeMap
	^ { 
		(MDObjectMaterializer new).
		(MDClassMaterializer new).
		(MDClassMaterializer new).
		(MDClassMaterializer new).
		MDKnownClassMaterializer class: self knownClasses.
		(MDSingletonMaterializer object: nil).
		(MDSingletonMaterializer object: true).
		(MDSingletonMaterializer object: false).
		(MDSmallIntegerMaterializer new).
		(MDSmallIntegerMaterializer new).
		(MDSmallIntegerMaterializer new).
		(MDLargeIntegerMaterializer class: LargePositiveInteger).
		(MDLargeIntegerMaterializer class: LargeNegativeInteger).
		(MDUtf8Materializer forSymbol).
		(MDUtf8Materializer forString).
		(MDUtf16Materializer new).
		(MDArrayMaterializer class: Array).
		(MDSetMaterializer class: Set).
		(MDDictionaryMaterializer class: Dictionary).
		(MDDictionaryMaterializer class: MDPropertyDictionary).
		(MDBytesMaterializer class: MDTimestamp).
		(MDBytesMaterializer class: MDHashstamp).
		(MDHashedObjectMaterializer new)
	 }! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/12/2008 02:18'!
initialize
	classMap := self createClassMap.
	typeMap := self createTypeMap.
	defaultSerializer := MDObjectSerializer type: 1.! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/30/2008 07:01'!
knownClasses
	^ { 
		MDSliceElement.
		MDDefinitionVariant.
		MDRemovalVariant.
		MDNullVersion.
		MDElementVersion.
		MDSnapshot.
		MDMemo.
		MDFakeElement.
		MDClassElement.
		MDClassCommentElement.
		MDInstVarElement.
		MDClassVarElement.
		MDClassInstVarElement.
		MDPoolImportElement.
		MDMethodElement
	 }! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/8/2008 20:03'!
materializerForType: anInteger 
	^ typeMap at: anInteger! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/19/2008 12:00'!
serializerForObject: anObject
	^ classMap
		at: anObject class
		ifAbsent: 
			[anObject isBehavior
				ifTrue: [MDClassSerializer new]
				ifFalse: [defaultSerializer]]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2008 23:49'!
stringClass
	^ (Smalltalk hasClassNamed: #ByteString)
		ifTrue: [Smalltalk at: #ByteString]
		ifFalse: [Smalltalk at: #String]! !

!MDSerializationMap methodsFor: 'as yet unclassified' stamp: 'cwp 4/7/2008 23:48'!
symbolClass
	^ (Smalltalk hasClassNamed: #ByteSymbol)
		ifTrue: [Smalltalk at: #ByteSymbol]
		ifFalse: [Smalltalk at: #Symbol]! !

Object subclass: #MDVolatileValue
	instanceVariableNames: 'lastImageName value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MC2-SqueakPlatform'!

!MDVolatileValue methodsFor: 'accessing' stamp: 'cwp 10/20/2008 21:26'!
value
	^ lastImageName = MDPlatform current imageName
		ifTrue: [value]
		ifFalse: [nil]! !

!MDVolatileValue methodsFor: 'accessing' stamp: 'cwp 10/21/2008 07:41'!
value: anObject 
	lastImageName := MDPlatform current imageName.
	^ value := anObject! !
MDAuthorInfo initialize!
MDNotificationAdaptor initialize!
